<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>Blockly Demo: Generating ChucK</title>
  <script src="../../blockly/dist/blockly_compressed.js"></script>
  <script src="../../blockly/dist/blocks_compressed.js"></script>
  <script src="../../blockly/dist/chuck_compressed.js"></script>
  <!-- <script src="../../blockly/msg/js/en.js"></script> -->
  <script src="../../blockly/build/msg/es.js"></script>
  <!-- <script src="../../blockly/build/msg/en.js"></script> -->
  <!-- <script src="https://unpkg.com/@blockly/plugin-typed-variable-modal@3.1.15/dist/index.js"></script> -->
  <script src="https://unpkg.com/@blockly/plugin-typed-variable-modal@5.0.6/dist/index.js"></script>
  <style>
    body {
      background-color: #fff;
      font-family: sans-serif;
    }
    h1 {
      font-weight: normal;
      font-size: 140%;
    }
  </style>
</head>
<body>
  <h1><a href="https://developers.google.com/blockly/">Blockly</a> &gt;
    <a href="../index.html">Demos</a> &gt; Generating ChucK</h1>

  <p>This is a simple demo of generating code from blocks and running
  the code in a sandboxed ChucK interpreter.</p>

  <p>&rarr; More info on <a href="https://developers.google.com/blockly/guides/configure/web/code-generators">Code Generators</a> and <a href="https://developers.google.com/blockly/guides/app-integration/running-javascript">Running ChucK</a>.</p>

  <p>
    <button onclick="showCode()">Show ChucK</button>
    <button onclick="runCode()">Run ChucK</button>
  </p>

  <div id="blocklyDiv" style="height: 480px; width: 600px;"></div>

  <xml xmlns="https://developers.google.com/blockly/xml" id="toolbox" style="display: none">
    <category name="Logic" colour="%{BKY_LOGIC_HUE}">
      <block type="controls_if"></block>
      <block type="logic_compare"></block>
      <block type="logic_operation"></block>
      <block type="logic_negate"></block>
      <block type="logic_boolean"></block>
    </category>
    <category name="Loops" colour="%{BKY_LOOPS_HUE}">
      <block type="controls_repeat_ext">
        <value name="TIMES">
          <block type="math_number">
            <field name="NUM">10</field>
          </block>
        </value>
      </block>
      <block type="controls_whileUntil"></block>
    </category>
    <category name="Math" colour="%{BKY_MATH_HUE}">
      <block type="math_number">
        <field name="NUM">123</field>
      </block>
      <block type="math_arithmetic"></block>
      <block type="math_single"></block>
    </category>
    <category name="Text" colour="%{BKY_TEXTS_HUE}">
      <block type="text"></block>
      <block type="text_length"></block>
      <block type="text_print"></block>
    </category>
    <category name="Variables" custom="CREATE_TYPED_VARIABLE" colour="%{BKY_VARIABLES_HUE}"></category>
    <category name="Osciladores" custom="CREATE_TYPED_VARIABLE1" colour="%{BKY_VARIABLES_HUE}"></category>
    <!-- <category name="Colours" custom="CREATE_TYPED_VARIABLE" colour="%{BKY_VARIABLES_HUE}"></category> -->
    <!-- <category name="Variables" custom="VARIABLE" colour="%{BKY_VARIABLES_HUE}"> -->
  </xml>

  <!-- Se puede hacer uso de estos bloques para el area de trabajo -->
  <xml xmlns="https://developers.google.com/blockly/xml" id="startBlockss" style="display: none">
    <block type="controls_if" inline="false" x="20" y="20">
      <mutation else="1"></mutation>
      <value name="IF0">
        <block type="logic_compare" inline="true">
          <field name="OP">EQ</field>
          <value name="A">
            <block type="math_arithmetic" inline="true">
              <field name="OP">MULTIPLY</field>
              <value name="A">
                <block type="math_number">
                  <field name="NUM">6</field>
                </block>
              </value>
              <value name="B">
                <block type="math_number">
                  <field name="NUM">7</field>
                </block>
              </value>
            </block>
          </value>
          <value name="B">
            <block type="math_number">
              <field name="NUM">42</field>
            </block>
          </value>
        </block>
      </value>
      <statement name="DO0">
        <block type="text_print" inline="false">
          <value name="TEXT">
            <block type="text">
              <field name="TEXT">Don't panic</field>
            </block>
          </value>
        </block>
      </statement>
      <statement name="ELSE">
        <block type="text_print" inline="false">
          <value name="TEXT">
            <block type="text">
              <field name="TEXT">Panic</field>
            </block>
          </value>
        </block>
      </statement>
    </block>
  </xml>

  <!-- Empezar el area de trabajo limpia -->
  <xml xmlns="https://developers.google.com/blockly/xml" id="startBlocks" style="display: none">
  </xml>

  <script>
    var demoWorkspace = Blockly.inject('blocklyDiv',
        {media: '../../blockly/media/',
         toolbox: document.getElementById('toolbox')});
    Blockly.Xml.domToWorkspace(document.getElementById('startBlocks'),
                               demoWorkspace);
    const createFlyout = function(workspace) {
      let xmlList = [];
      // Add your button and give it a callback name.
      const button = document.createElement('button');
      button.setAttribute('text', 'Create Typed Variable');
      button.setAttribute('callbackKey', 'callbackName');

      xmlList.push(button);

      // This gets all the variables that the user creates and adds them to the
      // flyout.
      const blockList = Blockly.VariablesDynamic.flyoutCategoryBlocks(workspace);
      xmlList = xmlList.concat(blockList);
      return xmlList;
    };

    demoWorkspace.registerToolboxCategoryCallback('CREATE_TYPED_VARIABLE', createFlyout);
    const typedVarModal = new TypedVariableModal(demoWorkspace, 'callbackName', [["Entero", "int"], ["Flotante", "float"], ["Texto", "string"]]);
    typedVarModal.init();

    const createFlyout1 = function(workspace) {
      let xmlList1 = [];
      // Add your button and give it a callback name.
      const button = document.createElement('button');
      button.setAttribute('text', 'Create Oscilador');
      button.setAttribute('callbackKey', 'callbackName1');

      xmlList1.push(button);

      // This gets all the variables that the user creates and adds them to the
      // flyout.
      const blockList1 = Blockly.VariablesDynamic.flyoutCategoryBlocks(workspace);
      xmlList1 = xmlList1.concat(blockList1);
      return xmlList1;
    };

    demoWorkspace.registerToolboxCategoryCallback('CREATE_TYPED_VARIABLE1', createFlyout1);
    const typedVarModal1 = new TypedVariableModal(demoWorkspace, 'callbackName1', [["Oscilador1", "Osc1"], ["Oscilador2", "Osc2"]]);
    typedVarModal1.init();

    function showCode() {
      // Generate ChucK code and display it.
      Blockly.Chuck.INFINITE_LOOP_TRAP = null;
      var code = Blockly.Chuck.workspaceToCode(demoWorkspace);
      console.log(code);
      alert(code);
    }

    function runCode() {
      // Generate ChucK code and run it.
      window.LoopTrap = 1000;
      Blockly.Chuck.INFINITE_LOOP_TRAP = 
          'if (--window.LoopTrap == 0) throw "Infinite loop.";\n';
      var code = Blockly.Chuck.workspaceToCode(demoWorkspace);
      Blockly.Chuck.INFINITE_LOOP_TRAP = null;
      try {
        eval(code);
      } catch (e) {
        alert(e);
      }
    }
  </script>

</body>
</html>
